﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.IO;
using System.Diagnostics;
using System.ComponentModel;

namespace Diplomski
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Prostorija> prostorije = new List<Prostorija>();
        int ID_Zakazani = 0;
       
        DataSet1TableAdapters.ProfesoriTableAdapter taP;
        DataSet1TableAdapters.RokoviTableAdapter taR;
        DataSet1TableAdapters.IspitiTableAdapter taI;
        DataSet1TableAdapters.ProstorijaTableAdapter taProstorija;
        DataSet1TableAdapters.ZakazaniTableAdapter taZ;

        DataSet1.RokoviDataTable dtR;
        DataSet1.ProfesoriDataTable dtP;
        DataSet1.IspitiDataTable dtI;
        DataSet1.ProstorijaDataTable dtProstorija;
        DataSet1.ZakazaniDataTable dtZ;
        public MainWindow()
        {
            InitializeComponent();
            
            taP = new Diplomski.DataSet1TableAdapters.ProfesoriTableAdapter();
            taR = new Diplomski.DataSet1TableAdapters.RokoviTableAdapter();
            taProstorija = new Diplomski.DataSet1TableAdapters.ProstorijaTableAdapter();
            taI = new Diplomski.DataSet1TableAdapters.IspitiTableAdapter();
            taZ = new Diplomski.DataSet1TableAdapters.ZakazaniTableAdapter();

            dtR = taR.GetData();
            dtP = taP.GetData();
            dtI = taI.GetData();
            dtProstorija = taProstorija.GetData();
            dtZ = taZ.GetData();

            foreach (DataSet1.ZakazaniRow r in dtZ.Rows)
            {
                if (r.ID > ID_Zakazani) ID_Zakazani = r.ID;
            }
            
            

        }
     
        public class Prostorija
        {
            private int kapacitet;
            private string naziv;
            private bool check;

            public Prostorija(int Kap, bool Check, string Naziv)
            {
                kapacitet = Kap; check = Check; naziv = Naziv;
            }

            public int Kapacitet
            {
                get { return kapacitet; }
                set { kapacitet = value; }
            }
            public bool Check
            {
                get { return check; }
                set { check = value; }
            }
            public string Naziv
            {
                get { return naziv; }
                set { naziv = value; }
            }
        }

        public void ucitaj_DataGrid()
        {
            DataSet1.RokoviDataTable dtR = taR.GetData();
            DataSet1.ProfesoriDataTable dtP = taP.GetData();
            DataSet1.IspitiDataTable dtI = taI.GetData();
            DataSet1.ProstorijaDataTable dtProstorija = taProstorija.GetData();
            DataSet1.ZakazaniDataTable dtZ = taZ.GetData();

            DataTable dtZakazani = new DataTable();
            dtZakazani.Columns.Add("ID", typeof(int));
            dtZakazani.Columns.Add("Profesor", typeof(string));
            dtZakazani.Columns.Add("SifraIspita", typeof(string));
            dtZakazani.Columns.Add("NazivIspita", typeof(string));
            dtZakazani.Columns.Add("Prostorija", typeof(string));
            dtZakazani.Columns.Add("Rok", typeof(string));
            dtZakazani.Columns.Add("Datum", typeof(string));
            dtZakazani.Columns.Add("Vreme", typeof(string));

            string profDG = "", sifraIspitaDG = "", nazivIspitaDG = "", prostorijaDG = "";

            bool pom = false, pom1 = false; int j = 0, i = 0;
            int[] niz = new int[4 * dtZ.Rows.Count];

            foreach (DataSet1.ZakazaniRow r in dtZ.Rows)
            {
                pom1 = false;
                foreach (int br in niz) { if (br.Equals(r.ID)) pom1 = true; } i++;
                if (pom1) continue;

                foreach (DataSet1.ProfesoriRow rp in dtP.Rows)
                {
                    
                    if (r.id_prof.Equals(rp.ID))
                        profDG += " " + rp.Profesor + " "; 
                }
                foreach (DataSet1.IspitiRow ri in dtI.Rows)
                {
                    if (r.id_ispita.Equals(ri.Sifra))
                    { sifraIspitaDG = " " + ri.Sifra + " "; nazivIspitaDG = " " + ri.Naziv + " "; }
                }
                foreach (DataSet1.ProstorijaRow rp in dtProstorija.Rows)
                {
                    if (r.id_prostorije.Equals(rp.Naziv))
                        prostorijaDG += " " + rp.Naziv + " ";
                }

                foreach (DataSet1.ZakazaniRow rr in dtZ.Rows)
                {

                    if (j == 0) { j++; continue; }


                    if (r.id_prof.Equals(rr.id_prof) && r.id_ispita.Equals(rr.id_ispita) && !r.id_prostorije.Equals(rr.id_prostorije)
                    && r.Rok.Equals(rr.Rok) && r.DatumVreme.Equals(rr.DatumVreme) && !r.ID.Equals(rr.ID))
                        pom = true;
                    else
                        pom = false;

                    if (pom)
                    {
                        foreach (DataSet1.ProstorijaRow rp in dtProstorija.Rows)
                        {
                            if (rr.id_prostorije.Equals(rp.Naziv))
                                prostorijaDG += " , " + rp.Naziv;
                        }
                        niz[i++] = rr.ID;
                    }
                }
                dtZakazani.Rows.Add(r.ID, profDG, sifraIspitaDG, nazivIspitaDG, prostorijaDG, r.Rok, r.DatumVreme.Day + "." + r.DatumVreme.Month + "." + r.DatumVreme.Year + ".", r.DatumVreme.ToShortTimeString());
                profDG = ""; sifraIspitaDG = ""; nazivIspitaDG = ""; prostorijaDG = "";
            }

            dataGrid1.DataContext = dtZakazani;
            //*********************************************************************************>> sortiranje po ID
            ICollectionView view = CollectionViewSource.GetDefaultView(dataGrid1.Items);
            view.SortDescriptions.Clear();
            view.SortDescriptions.Add(new SortDescription("ID", ListSortDirection.Ascending));
            view.Refresh();

        }
        private void Load_comboBoxIspit()
        {
            string ime = ""; DataSet1.IspitiDataTable dtI = taI.GetData();
            DataTable dtPomIspit = new DataTable();
            dtPomIspit.Columns.Add("ID", typeof(int));
            dtPomIspit.Columns.Add("Ime", typeof(string));
            foreach (DataSet1.IspitiRow r in dtI.Rows)
            {
                
                if (comboBoxProfesor.SelectedValue.Equals(r.id_prof) || 0 == (int)comboBoxProfesor.SelectedValue)
                {
                    ime += r.Sifra + " " + r.Naziv;
                    dtPomIspit.Rows.Add(r.Sifra, ime);
                    ime = "";
                }
            }
            Binding b = new Binding() { Source = dtPomIspit };
            this.comboBoxIspit.SetBinding(ComboBox.ItemsSourceProperty, b);
            this.comboBoxIspit.DisplayMemberPath = "Ime";
            this.comboBoxIspit.SelectedValuePath = "ID";
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //***************************************************** Binding za comboBoxProfesor
            comboBoxProfesor.DataContext = dtP;

            //****************************************************************** Binding za comboBoxProstorija
        
            foreach (DataSet1.ProstorijaRow r in dtProstorija.Rows)
            {
                prostorije.Add(new Prostorija(r.Kapacitet, false, r.Naziv));
            }
            this.comboBoxProstorija.DataContext = prostorije;
            //*********************************************************************************** puni comboBoxRok
            comboBoxRok.DataContext = dtR;

            ucitaj_DataGrid();
            
        }
        private int vratiBrojStudenata()
        {
            int brs = 0;
            try
            {
                DataSet1.IspitiDataTable dtI = taI.GetData();
                foreach (DataSet1.IspitiRow r in dtI.Rows)
                {
                    if (comboBoxIspit.SelectedValue.Equals(r.Sifra))
                        brs = r.BrojStudenata;
                }
            }
            catch { brs = 0; }
            return brs;
        }
        private int kapacitetProstorija()
        {
            int kap = 0;
            foreach (Prostorija p in prostorije)
            {
                if (p.Check)
                    kap += p.Kapacitet;
            }
            return kap;
        }
        private bool provera()
        {
            if (vratiBrojStudenata() > kapacitetProstorija()) return false;
            else return true;
        }
        private int proveraTermina(DateTime PocetakIspita, DateTime TrajanjeIspita)
        {
            int kontrol = 0;
            DataSet1.ZakazaniDataTable dtZ = taZ.GetData();
            
            DateTime MinTabela = new DateTime();
            DateTime MaxTabela = new DateTime();
            
           
            foreach (DataSet1.ZakazaniRow r in dtZ.Rows)
            {
                if (r.DatumVreme.Date.Equals(PocetakIspita.Date))
                {
                    MinTabela = r.DatumVreme;
                    MaxTabela = r.DatumVreme.AddHours(r.Trajanje.Hour).AddMinutes(r.Trajanje.Minute);
                    
                }
                MessageBox.Show(""+ PocetakIspita.ToString() + Environment.NewLine +
                                   TrajanjeIspita.ToString() + Environment.NewLine +
                                    MinTabela.ToString() + Environment.NewLine +
                                    MaxTabela.ToString());

                if (PocetakIspita < MinTabela && TrajanjeIspita < MinTabela) kontrol = 0;
                else if (PocetakIspita > MaxTabela && TrajanjeIspita > MaxTabela) kontrol = 0;
                else kontrol = r.ID;
            }

            return kontrol;
        }

        private void btnZakazi_Click(object sender, RoutedEventArgs e)
        {
            double sat = 0, min = 0; int id_kolizije = 0;
            DateTime vreme = new DateTime(); // datum i vreme pocetka ispita
            DateTime trajanje = new DateTime(); // trajanje ispita
            DataSet1.ZakazaniDataTable dtZ = taZ.GetData();

            sat = double.Parse(txtVremeSati.Text);
            min = double.Parse(txtVremeMin.Text);

            try { vreme = (DateTime)calendar.SelectedDate; }
            catch { vreme = calendar.DisplayDate; }
            vreme = vreme.AddHours(sat);
            vreme = vreme.AddMinutes(min);// sad je vreme min mog intervala

            sat = double.Parse(txtTrajanjeSati.Text);
            min = double.Parse(txtTrajanjeMin.Text);

            trajanje = vreme;
            trajanje = trajanje.AddHours(sat);
            trajanje = trajanje.AddMinutes(min); // sad je trajanje max mog intervala

            id_kolizije = proveraTermina(vreme, trajanje);

            try
            {
                bool prostorUnet = false;
                if (id_kolizije == 0)
                {
                    if (provera())
                    {

                        foreach (Prostorija p in prostorije)
                        {
                            if (p.Check)
                            {
                                taZ.Insert(++ID_Zakazani, int.Parse(comboBoxProfesor.SelectedValue.ToString()),
                                       int.Parse(comboBoxIspit.SelectedValue.ToString()),
                                       p.Naziv,
                                       comboBoxRok.SelectedValue.ToString(),
                                       vreme, trajanje);
                                prostorUnet = true;
                            }

                        }
                        if (prostorUnet)
                            MessageBox.Show("Ispit zakazan !");
                        else
                            MessageBox.Show("Niste izabrali sve podatke !");
                    }
                    else MessageBox.Show("Kapacitet izabranih prostorija nije dovoljan da bi se u njima odrzao ovaj ispit!");
                }
                else
                {
                    //foreach (DataSet1.ZakazaniRow r in dtZ.Rows)
                    //{
                        //if(id_kolizije.Equals(r.ID))
                            MessageBox.Show("U izabranom terminu je vec zakazan ispit!" + Environment.NewLine + 
                                             "PREKLAPANJE TERMINA! " + id_kolizije);
                    //}
                }
            }
            catch
            {
                MessageBox.Show("Nije uspelo!");
            }
            ucitaj_DataGrid();
        }

        private void btnIzvezi_Click(object sender, RoutedEventArgs e)
        {
            dataGrid1.SelectionMode = DataGridSelectionMode.Extended;
            dataGrid1.SelectAllCells();
            dataGrid1.ClipboardCopyMode = DataGridClipboardCopyMode.IncludeHeader;
            ApplicationCommands.Copy.Execute(null, dataGrid1);
            string docPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "/Raspored_Ispita.csv";
            string dataExp = Clipboard.GetData(DataFormats.CommaSeparatedValue) as string;
            File.WriteAllText(docPath, dataExp);
            if (MessageBox.Show("Podaci sacuvani u Documents/Raspored_Ispita.csv . Da li zelite da otvorite taj fajl ?", "Podaci sacuvani u Excel dokumentu", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
            {
                Process.Start(docPath);

            }

            dataGrid1.UnselectAllCells();
        }


        private void btnBrisanje_Click(object sender, RoutedEventArgs e)
        {
            object selected = dataGrid1.SelectedItem;
            DataSet1.ZakazaniDataTable dtZ = taZ.GetData();
            try
            {
                DataRow row = ((DataRowView)selected).Row;
                int pomId = 0, pomId_prof = 0, pomId_ispit = 0;
                string pomRok = "", pomId_Prostor = ""; DateTime pomDatum = DateTime.Today, pomVreme = DateTime.Today;
                foreach (DataSet1.ZakazaniRow r in dtZ.Rows)
                {
                    if (!pomId.Equals(r.ID) && pomId_prof.Equals(r.id_prof) && pomId_ispit.Equals(r.id_ispita) &&
                        !pomId_Prostor.Equals(r.id_prostorije) && pomRok.Equals(r.Rok) && pomDatum.Equals(r.DatumVreme))
                    { taZ.Delete(r.ID); }

                    pomId = r.ID; pomId_prof = r.id_prof; pomId_ispit = r.id_ispita; pomId_Prostor = r.id_prostorije;
                    pomRok = r.Rok; pomDatum = r.DatumVreme; 

                    if (r.ID.Equals(row[0]))
                        if (MessageBox.Show("Da li ste sigurni da zelite da obrisete izabrani ispit ?", " ", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
                        { taZ.Delete(r.ID); }
                }
            }
            catch
            {
                MessageBox.Show("Morate prvo izabrati jedan ispit (red u tabeli) !");
            }
            ucitaj_DataGrid(); // nejasno zasto taZ.Delete(... trazi ovoliko argumenata a ne samo ID
        }

        private void comboBoxProfesor_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Load_comboBoxIspit(); lblBrStudenata.Content = "";
            //lblProfKabinet.Visibility = Visibility.Visible;
            //lblProfKonsult.Visibility = Visibility.Visible;
            //lblProfEmail.Visibility = Visibility.Visible;
        }
  
        private void comboBoxIspit_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            lblBrStudenata.Content = "Prijavljenih studenata: " + vratiBrojStudenata().ToString();
            
        }

        private void comboBoxProstorija_DropDownClosed(object sender, EventArgs e)
        {
            lblKapac.Content = kapacitetProstorija().ToString();
            
        }

    }
}
